<?php

/************************************************************************************/
/* PHP-NUKE: Web Portal System                                                      */
/* ===========================                                                      */
/*                                                                                  */
/* Copyright (c) 2001 by Francisco Burzi (fburzi@ncc.org.ve)                        */
/* http://phpnuke.org                                                               */
/*                                                                                  */
/* SiteMail                                                                         */
/* v1.1                                                                             */
/*                                                                                  */
/* Copyright  2002 by: Maty Scripts (webmaster@mat.allfreetemplates.com)           */
/* http://mat.allfreetemplates.com                                                  */
/*                                                                                  */
/* This program is free software. You can redistribute it and/or modify             */
/* it under the terms of the GNU General Public License as published by             */
/* the Free Software Foundation; either version 2 of the License.                   */
/*                                                                                  */
/************************************************************************************/

if (!eregi("modules.php", $PHP_SELF)) {
	die ("You can't access this file directly...");
}
require_once("mainfile.php");
$module_name = basename( dirname( __FILE__ ) );
$FlagPath = "images/forum/flags/";

if( isset( $newlang ) ) {
   include( "modules/$module_name/language/lang-$newlang.php" );
   $language = $newlang;
}
elseif ( isset( $lang ) ) {
   include( "modules/$module_name/language/lang-$lang.php" );
   $language = $lang;
}
else {
   include( "modules/$module_name/language/lang-$language.php" );
}

/******************************************************************************/
/* FUNCTION: ShowSiteMailUserStatistics()                                     */
/* Give a general overview of all users which use SiteMail                    */
/******************************************************************************/
function ShowSiteMailUserStatistics( $page, $sort_on )
{
   global $dbi, $user_prefix, $module_name, $FlagPath;
   
   include( "header.php" );

   $who_online_now = "";
   
   // Read Configuration Settings
   $result = sql_query( "SELECT BGMailColor, BGTitleColor, BGCellColor1, BGCellColor2, TitleFontColor, CellFontColor, StatsUsersPP from ".$user_prefix."_sitemail_cnf WHERE uid='1'", $dbi );
   list( $BGMailColor, $BGTitleColor, $BGCellColor1, $BGCellColor2, $TitleFontColor, $CellFontColor, $StatsUsersPP ) = sql_fetch_row( $result, $dbi );
   
   // Read Users which are on-line
   $OnLineSMUsers = " ".OnlineSiteMailUsers();
   
   // Get total amount SiteMail Users
   $total_users = sql_num_rows( sql_query( "SELECT * FROM ".$user_prefix."_sitemail_users", $dbi) );

   // Calculate how many pages have to be printed
   // $StatsUsersPP telles how many users per page have to be displayed
   // $start_row tells the query where to start in the User-List
   // $Page are the number of pages that should be displayed in case the total amount of SiteMail users > $StatsUsersPP (allowed Users per Page)
   if( $total_users > $StatsUsersPP )
   {
      $nbr_pages = ceil( $total_users / $StatsUsersPP );
      if( $page > $nbr_pages) { $page = $nbr_pages; }
      $start_row = ( $page - 1 ) * $StatsUsersPP;
   }
   else  // show all usernames at once
   {
      $start_row = 0;
      $nbr_pages = 1;
      $page = 1;
   }
   
   OpenTable();
   echo "<h4 align=center><b>"._MSM_STATTITLE1."</b></h4>";
   echo "<center><b>$total_users </b>"._MSM_STATTITLE2."</center>";
   CloseTable();

   echo "<br>\n";
   OpenTable();
   echo "
      <div align=\"center\">
      <center>
         <table border=\"1\" cellpadding=\"2\" cellspacing=\"2\" width=\"80%\" style=\"border-style: double\">
         <tr>
            <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$BGTitleColor\" style=\"color:$TitleFontColor\"><b>"._MSM_STATTITLE4."</b></td>
            <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$BGTitleColor\" style=\"color:$TitleFontColor\"><b>"._MSM_STATTITLE3."</b></td>
            <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$BGTitleColor\" style=\"color:$TitleFontColor\"><b>"._MSM_STATTITLE11."</b></td>
            <td width=\"18%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$BGTitleColor\" style=\"color:$TitleFontColor\"><b>"._MSM_STATTITLE5."</b></td>
            <td width=\"26%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$BGTitleColor\" style=\"color:$TitleFontColor\"><b>"._MSM_STATTITLE6."</b></td>
            <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$BGTitleColor\" style=\"color:$TitleFontColor\"><b>"._MSM_STATTITLE7."</b></td>
            <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$BGTitleColor\" style=\"color:$TitleFontColor\"><b>"._MSM_STATTITLE8."</b></td>
            <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$BGTitleColor\" style=\"color:$TitleFontColor\"><b>"._MSM_STATTITLE9."</b></td>
            <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$BGTitleColor\" style=\"color:$TitleFontColor\"><b>"._MSM_STATTITLE10."</b></td>
         </tr>
         ";

   // Perform query in SiteMail Users Table
   // $start_row tells the query where to start in the User-List   
   if( $sort_on == 1 ) { $result = sql_query( "SELECT uname, email, user_from, mail_counter, pop3_counter FROM $user_prefix"._sitemail_users." ORDER BY uname ASC, name ASC LIMIT $start_row, $StatsUsersPP", $dbi ); }
   else if( $sort_on == 2 ) { $result = sql_query( "SELECT uname, email, user_from, mail_counter, pop3_counter FROM $user_prefix"._sitemail_users." ORDER BY email ASC, uname ASC LIMIT $start_row, $StatsUsersPP", $dbi ); }
   else if( $sort_on == 3 ) { $result = sql_query( "SELECT uname, email, user_from, mail_counter, pop3_counter FROM $user_prefix"._sitemail_users." ORDER BY mail_counter DESC, uname ASC LIMIT $start_row, $StatsUsersPP", $dbi ); }
   else { $result = sql_query( "SELECT uname, email, user_from, mail_counter, pop3_counter FROM $user_prefix"._sitemail_users." ORDER BY pop3_counter DESC, uname ASC LIMIT $start_row, $StatsUsersPP", $dbi ); }
   
   if( ! $result )
   {
      echo "<br><h5 align=center><b>"._MSM_ERRORSTATISTICS."</b></h5><br>\n";
      exit();
   }
   $counter = $start_row + 1;
   while( list ( $uname, $email, $user_from, $mail_counter, $pop3_counter ) = sql_fetch_row( $result, $dbi ) )
   {   
      $tot_emails = sql_num_rows( sql_query( "SELECT * FROM ".$user_prefix."_sitemail_email WHERE uname='$uname'", $dbi) );
      $tot_stored = sql_num_rows( sql_query( "SELECT * FROM ".$user_prefix."_sitemail_sentbox WHERE uname='$uname'", $dbi) );
      
      $OnLineSMUsers = strtolower( $OnLineSMUsers );
      $Nuname = strtolower( $uname );

      if( strpos ( $OnLineSMUsers, $Nuname ) ) { $LineStat = "<img src=\"modules/$module_name/images/online.gif\" border=\"0\">"; } else { $LineStat = "<img src=\"modules/$module_name/images/offline.gif\" border=\"0\">"; }

      if( ( $user_from == "" ) OR ( file_exists( $FlagPath.$user_from ) == 0 ) )
      { $FlagPathFile = "<img src=\"modules/$module_name/images/quest.gif\" align=\"absmiddle\" border=\"0\">"; } else { $FlagPathFile = "<img src=".$FlagPath.$user_from." width=\"22\" height=\"14\" align=\"absmiddle\" border=\"0\">"; }

      if( $counter % 2 ) { $CellColor = $BGCellColor1; } else { $CellColor = $BGCellColor2; }
           
      echo "
         <tr>
         <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$CellColor\" style=\"color:$CellFontColor\"><b>$counter</b></td>
         <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$CellColor\" style=\"color:$CellFontColor\"><b>$LineStat</b></td>
         <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$CellColor\" style=\"color:$CellFontColor\"><b>$FlagPathFile</b></td>
         <td width=\"18%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$CellColor\" style=\"color:$CellFontColor\"><b><a href=modules.php?name=$module_name&amp;file=statistics&amp;op=ShowSiteMailUserInfo&amp;uname=$uname>$uname</a></b></td>
         <td width=\"26%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$CellColor\" style=\"color:$CellFontColor\"><b>$email</b></td>
         <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$CellColor\" style=\"color:$CellFontColor\"><b>$mail_counter</b></td>
         <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$CellColor\" style=\"color:$CellFontColor\"><b>$pop3_counter</b></td>
         <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$CellColor\" style=\"color:$CellFontColor\"><b>$tot_emails</b></td>
         <td width=\"8%\" align=\"center\" valign=\"middle\" height=\"35\" style=\"border-style: double\" bgcolor=\"$CellColor\" style=\"color:$CellFontColor\"><b>$tot_stored</b></td>
         </tr>\n";
      $counter += 1;
   }
   echo "
         </table>
         </center>
         </div>
   ";
   CloseTable();

   if( $sort_on == 1 ) { $ssort_on = _MSM_STATNAME; }
   else if( $sort_on == 2 ) { $ssort_on = _MSM_STATEMAIL; }
   else if( $sort_on == 3 ) { $ssort_on = _MSM_STATSENT; }
   else { $ssort_on = _MSM_STATPOP3; }
   
   // Display Pages + Sort on
   echo "<br><br><center>"._MSM_STATPAGE.": <b>$page</b>&nbsp;&nbsp;"._MSM_STATSORTON.": <b>$ssort_on</b><br><br>\n";
   if( $nbr_pages > 1 )
   {
      for( $i = 1; $i <= $nbr_pages; $i++ )
      {
         echo "<b>[ <a href=\"modules.php?name=$module_name&amp;file=statistics&amp;page=$i&amp;sort_on=$sort_on\">$i</a> ]</b>";
      }
      echo "</center>";
   }  

   echo "<br>\n";
   OpenTable();
   
   // Display sort options
   echo "<center>Sort on:&nbsp;<b>[</b>&nbsp;
               <a href=\"modules.php?name=$module_name&amp;file=statistics&amp;page=1&amp;sort_on=1\">"._MSM_STATNAME."</a>&nbsp;&nbsp;<b></b>&nbsp;&nbsp;
               <a href=\"modules.php?name=$module_name&amp;file=statistics&amp;page=1&amp;sort_on=2\">"._MSM_STATEMAIL."</a>&nbsp;&nbsp;<b></b>&nbsp;&nbsp;
               <a href=\"modules.php?name=$module_name&amp;file=statistics&amp;page=1&amp;sort_on=3\">"._MSM_STATSENT."</a>&nbsp;&nbsp;<b></b>&nbsp;&nbsp;
               <a href=\"modules.php?name=$module_name&amp;file=statistics&amp;page=1&amp;sort_on=4\">"._MSM_STATPOP3."</a>
               &nbsp;<b>]</b></center>";
   CloseTable();
   
   echo "<br>\n";
   OpenTable();
   echo "<center>[ <a href=\"modules.php?name=$module_name\">"._MSM_GOBACK."</a> ]</center>\n";
   CloseTable();
   
   include( "footer.php" );
}

/******************************************************************************/
/* FUNCTION: ShowSiteMailUserInfo                                             */
/* Give a general overview of selected users                                  */
/******************************************************************************/
function ShowSiteMailUserInfo( $uname )
{
    global $site_logo, $sitename, $nukeurl, $user_prefix, $dbi, $module_name, $FlagPath;

    $result = sql_query( "SELECT name, uname, email, url, user_from, user_avatar, user_posts, user_regdate from ".$user_prefix."_users WHERE uname='$uname'", $dbi );
    $userinfo1 = sql_fetch_array( $result, $dbi );

    $result = sql_query( "SELECT user_from, mail_counter, pop3_counter from ".$user_prefix."_sitemail_users WHERE uname='$uname'", $dbi );
    $userinfo2 = sql_fetch_array( $result, $dbi );

    // Check if FLAG.GIF Exists
    if( ( $userinfo2[user_from] == "" ) OR ( file_exists( $FlagPath.$userinfo2[user_from] ) == 0 ) )
    {
       $FlagPathFile = "modules/$module_name/images/quest.gif";
    }
    else
    {
       $FlagPathFile = $FlagPath.$userinfo2[user_from];
    }
    
    echo "
    <html>
    <head><title>$sitename - "._MSM_STATUSRLINE." $uname</title></head>
    <body bgcolor=\"#ffffff\" text=\"#000000\">

    <table width=\"640\" align=\"center\" border=\"1\" cellspacing=\"1\" cellpadding=\"1\" bgcolor=\"#ffffff\"> <td colspan=\"2\"><tr>
    <td colspan=\"2\" align=\"center\"><img src=\"images/$site_logo\" border=\"0\" alt=\"\"></b></td></tr>
    <td colspan=\"2\" align=\"center\"><font class=\"content\"><b>$title</b></font><font class=tiny>"._MSM_STATUSRLINE."<b> $uname</b>&nbsp&nbsp<img src=\"modules/Forums/images/avatars/$userinfo1[user_avatar]\" align=\"absmiddle\"></td></tr>

    <font class=\"content\">

    <tr><td><img src=\"modules/$module_name/images/mlatest.gif\" width=\"19\" height=\"14\" align=\"absmiddle\">"._MSM_STATUSRFN."</td><td> $userinfo1[name] </td></tr>
    <tr><td><img src=\"modules/$module_name/images/mlatest.gif\" width=\"19\" height=\"14\" align=\"absmiddle\">"._MSM_STATUSRLN."</td><td> $userinfo1[uname]</td></tr>
    <tr><td><img src=\"modules/$module_name/images/priv.gif\" width=\"19\" height=\"14\" align=\"absmiddle\">"._MSM_STATUSREMAIL."</td><td> <a href=\"mailto:$userinfo1[email]\">$userinfo1[email]</a></td></tr>
    <tr><td><img src=\"modules/$module_name/images/www.gif\" width=\"19\" height=\"14\" align=\"absmiddle\">"._MSM_STATUSRWWW."</td><td> <a href=".$userinfo1[url]." target=_new>$userinfo1[url]</a></td></tr>
    <tr><td><img src=\"modules/$module_name/images/mlatest.gif\" width=\"19\" height=\"14\" align=\"absmiddle\">"._MSM_STATUSRRD."</td><td> $userinfo1[user_regdate] </td></tr>
    <tr><td><img src=\"$FlagPathFile\" width=\"19\" height=\"14\" align=\"absmiddle\">"._MSM_STATUSRUF."</td><td>". basename( $userinfo2[ user_from ], ".gif" )." </td></tr>
    <tr><td><img src=\"modules/$module_name/images/news.gif\" width=\"19\" height=\"14\" align=\"absmiddle\">"._MSM_STATSTORIESPUBLISHED."</td><td>$userinfo1[user_posts] </td></tr>
    <tr><td><img src=\"modules/$module_name/images/count.gif\" width=\"19\" height=\"14\" align=\"absmiddle\">&nbsp;"._MSM_STATSENT."</td><td> $userinfo2[mail_counter] </td></tr>
    <tr><td><img src=\"modules/$module_name/images/count.gif\" width=\"19\" height=\"14\" align=\"absmiddle\">&nbsp;"._MSM_STATPOP3."</td><td> $userinfo2[pop3_counter] </td></tr>
        
    </font>
    </td></tr></table></td></tr></table>

    <br><center><font class=\"content\">"._MSM_STATCOMESFROM." $sitename<br>
    <a href=\"$nukeurl\">$nukeurl</a><br><br>
    "._MSM_STATTHEURL."<br>
    <a href=modules.php?name=Your_Account&op=userinfo&uname=$uname>$uname</a>
    </font>
    </table><br>
    </body>
    </html>
    ";

} // END function ShowSiteMailUserInfo()

/******************************************************************************/
/* FUNCTION: OnlineSiteMailUsers                                              */
/* Check if there are SiteMail Users Online                                   */
/******************************************************************************/
function OnlineSiteMailUsers()
{
   global $dbi, $user_prefix, $module_name;

   $who_online_now = '';
   $result = sql_query( "SELECT username, guest FROM $user_prefix"._session." where guest=0", $dbi );
   while ( $session = sql_fetch_array( $result, $dbi ) )
   {
      if( isset( $session["guest"] ) and $session[ "guest" ] == 0 )
      {
         $who_online_now .= $session[ username ]."\n";
      }
   }
   return $who_online_now;
}

/***************************************************/
/****************** PROGRAM START ******************/
/***************************************************/
switch ( $op )
{
    case "ShowSiteMailUserStatistics":
       ShowSiteMailUserStatistics( $page, $sort_on );
    break;

    case "ShowSiteMailUserInfo":
       ShowSiteMailUserInfo( $uname );
    break;

    case "OnlineSiteMailUsers":
       OnlineSiteMailUsers();
    break;

    default:
	ShowSiteMailUserStatistics( $page, $sort_on );
}


?>